-- DCS replacement stub (export to TARGET)
local STUB_DURATION_SEC	= 5

package.path = package.path..";.\\LuaSocket\\?.lua"

-- DCS FUNCTION STUBS:
-- function LoCreateCoroutineActivity(idx_, delay_, interval_) --{{{
local stub_loop_index = 0
local stub_loop_interval = 1
function LoCreateCoroutineActivity(idx_, delay_, interval_)
--	print("\nExport_stub: LoCreateCoroutineActivity(idx_=" .. idx_ .. ", delay_=" .. delay_ .. ", interval_=" .. interval_ .. "):")
	stub_loop_interval = interval_

	sleep(delay_)

	LuaExportStart()
--	print("\nExport_stub: LoCreateCoroutineActivity: Entering dispatcher loop:\n")
	repeat
		stub_loop_index = stub_loop_index + 1
		CoroutineResume(idx_, stub_loop_index)
		sleep(interval_)
	until (stub_loop_index * interval_) >= STUB_DURATION_SEC
	LuaExportStop()
--	print("\nExport_stub: LoCreateCoroutineActivity: ...stub LoCreateCoroutineActivity ...done ")

end --}}}
-- function GetDevice(num_) {{{
function GetDevice(num_)
	--print("Export_stub: GetDevice(num_=" .. num_ .. ")")
	return MainPanel
end --}}}
-- MainPanel.get_argument_value() {{{
local lightSystemValues = { 0.9 , 0.8 , 0.7 , 0.6 , 0.5 , 0.4 , 0.3 , 0.2 , 0.1 , 0 }
MainPanel = {
    get_argument_value = function(self, arg_number_)
		--cal i = 1 + (stub_loop_index % table.getn(lightSystemValues))
		local i = 1 + math.floor(table.getn(lightSystemValues) * (stub_loop_interval * stub_loop_index) / 2.0)
		if(i > table.getn(lightSystemValues)) then i= table.getn(lightSystemValues); end
--		print("MainPanel.get_argument_value: i="..i)
		local v = lightSystemValues[i]
--		print("Export_stub: MainPanel:get_argument_value(arg_number_=["..arg_number_.."]) ...return["..v.."]")
		return v
    end,
}
--}}}
-- LoGetAltitudeAboveGroundLevel {{{
local altitudes = { 100 , 80, 50 , 40 , 30 , 20 , 10 , 5 , 3 , 2 , 1 , 0 }
function LoGetAltitudeAboveGroundLevel()
	local i = 1 + math.floor(table.getn(altitudes) * (stub_loop_interval * stub_loop_index) / STUB_DURATION_SEC)
--	print("LoGetAltitudeAboveGroundLevel: i="..i)
	local v = altitudes[i]
--	print("Export_stub: LoGetAltitudeAboveGroundLevel() ...return["..v.."]")
	return v
end
--}}}
-- LoGetMechInfo (...devenue introuvable dans DCS 1108) {{{
local speedbrakes = { 0.9 , 0.8 , 0.7 , 0.6 , 0.5 , 0.4 , 0.3 , 0.2 , 0.1 , 0 }
function LoGetMechInfo() -- mechanization info
	local i = 1 + math.floor(table.getn(speedbrakes) * (stub_loop_interval * stub_loop_index) / STUB_DURATION_SEC)
--	print("LoGetMechInfo: i="..i)
	local value  = speedbrakes[i]
	local status = 0
	return {
		gear          = {status,value,main = {left = {rod},right = {rod},nose =  {rod}} },
		flaps		  = {status,value},
		speedbrakes   = {status,value},
		refuelingboom = {status,value},
		airintake     = {status,value},
		noseflap      = {status,value},
		parachute     = {status,value},
		wheelbrakes   = {status,value},
		hook          = {status,value},
		wing          = {status,value},
		canopy        = {status,value},
		controlsurfaces = {elevator = {left,right},eleron = {left,right},rudder = {left,right}} -- relative vlues (-1,1) (min /max) (sorry:(
	} 
end
--}}}

--- UTIL:
-- function sleep(sec_) {{{
require("socket")
function sleep(sec_)
	socket.select(nil, nil, sec_)
end --}}}

