if not GetDevice then
	print("TargetBridge: GetDevice() is undefined. *** Requires DCS or Export_stub.lua ***")
	os.exit()
end

-- socket dependeny
package.path	= package.path..";.\\LuaSocket\\?.lua"
package.cpath	= package.cpath..";.\\LuaSocket\\?.dll"

local print		= print
local string	= require("string")
local socket	= require("socket")
local coroutine	= coroutine
local getArgVal	= GetDevice(0).get_argument_value
local getAltRad	= LoGetAltitudeAboveGroundLevel

TargetBridge = {
  consoleLight	= -1
, altRad		= -1
, speedbrakes	= -1
}

module("TargetBridge")

    function Start() --{{{
        host	= host or "localhost"
        port	= port or 5001 -- 8080
        ip		= socket.dns.toip(host)
        c		= socket.udp()
		local buf = "Start"
		print(" = TargetBridge.Start(): c:sendto("..buf..")")
		socket.try(c:sendto(string.format("Start:"), ip, port))
    end
    --}}}
    function Stop() --{{{
		local buf = "Stop"
		print(" * TargetBridge.Stop(): c:sendto("..buf..")")
		socket.try(c:sendto(buf, ip, port))
        c:close()
		c = nil
    end
    --}}}
    function ExportBeforeNextFrame() --{{{
    end
    --}}}
    function ExportWarthog(t) --{{{
		print("...TargetBridge.ExportWarthog(t=" .. t .. ")")
		local buf = ""
		local val   = -1
		---[=[ consoleLight --{{{
		if getArgVal then
			print("...calling val = getArgVal(800):")
			val = getArgVal(800)
			print(".val = getArgVal(800)=[" .. val .. "]")
		else
			print("...getArgVal is nil")
		end

print(".consoleLight=[" .. consoleLight .. "]")
		if val ~= consoleLight then
			consoleLight = val
			if(string.len(buf) > 0) then buf = buf .."," end
			buf = buf ..        string.format("consoleLight=%.2f", consoleLight)
print("...buf=[" .. buf .. "]")
		end
		--]=]--}}}
		---[=[-- altitude {{{
		if getAltRad then
			print("...calling getAltRad():")
			val = getAltRad()
			print(".val = getAltRad()=[" .. val .. "]")
		else
			print("...getAltRad is nil")
		end
print(".altRad=[" .. altRad .. "]")
		if(val > 1.1*altRad) or (val < 0.9*altRad) then
			altRad = val
			if(string.len(buf) > 0) then buf = buf .."," end
			buf = buf ..        string.format("altitude=%d", altRad)
		end
		--]=]--}}}
		--[=[ -- LoGetMechInfo {{{
		print("...TargetBridge.LoGetMechInfo():")
		if(LoGetMechInfo) then
			val= LoGetMechInfo()
			print("...TargetBridge.LoGetMechInfo() returned: val.speedbrakes[2]=["..val.speedbrakes[2].."]") -- {status,value}
			if(val.speedbrakes[2] > 1.1*speedbrakes) or (val.speedbrakes[2] < 0.9*speedbrakes) then
				speedbrakes = val.speedbrakes[2]
				if(string.len(buf) > 0) then buf = buf .."," end
				buf = buf ..        string.format("speedbrakes=%f", speedbrakes)
			end
		else
				print(" * TargetBridge.LoGetMechInfo() NOT IMPLEMENTED")
		end
		--]=]--}}}
		--[=[-- getArgVal(0...1000) -- attempts at accessing marguments of interest {{{
		for i=0,1000, 1 do
			val =    getArgVal(i) or "undefined"
			if(val>0 and val<1) then
				print("...TargetBridge.getArgVal("..i..")=["..val.."]")
			end
		end
		print("------------------------------------------------")
		--]=]--}}}
		-- send to TARGET {{{
		if(string.len(buf) > 0) then
			print("...TargetBridge.ExportWarthog(t=".. string.format("%3d", t) .."): c:sendto("..buf..")")
			socket.try(c:sendto(buf, ip, port))
		end
		--}}}
    end
    --}}}
	function ExportCoroutine(t) --{{{
		print("...ExportCoroutine(t="..t..")")
		repeat
			ExportWarthog(t)
			t = coroutine.yield()
		until c == nil
	end
	--}}}

